#include <stdio.h>
#include <math.h>

#include ".\INC\uusbd.h"
#include "usensorc.h"

#define NUM_INTERFACE	0  // dumpC^[tF[X̔ԍ
#define NUM_PIPE		0  // dumppCv̔ԍ
#define LOOPCOUNT		10 // JԂ

#define maxControllers 30
//#define DEBUG				// ʕ\tO

USHORT get_max_packet(HUSB husb, DWORD if_num, DWORD pipe_num){
	char *buf,*p;
	USHORT max_len;
	DWORD pipe_count, len;
	BOOL ok;
	USB_CONFIGURATION_DESCRIPTOR conf;
	PUSB_ENDPOINT_DESCRIPTOR endp_descriptor;

	/* ܂RtBO[VfBXNv^[̂ݓđŜ̑傫m */
	ok = Uusbd_GetConfigurationDescriptor(husb,(char*)&conf, sizeof(conf));
	if(!ok) return 0;
	len = conf.wTotalLength;
	buf = (char*)malloc(len);

	/* Ŝ𓾂 */
	ok = Uusbd_GetConfigurationDescriptor(husb,buf, len);
	if(!ok) return 0;

	p = buf; max_len = 0; pipe_count = 0; ok = FALSE;
	while(len>0) {
		if(p[1] == USB_INTERFACE_DESCRIPTOR_TYPE){		// interface descriptor
			if((unsigned) p[2] == if_num) ok = TRUE;
			else ok = FALSE;
			pipe_count = 0;
		}
		if(p[1] == USB_ENDPOINT_DESCRIPTOR_TYPE && ok){	// endpoint descriptor
			if(pipe_count == pipe_num) { // found !!
				endp_descriptor = (PUSB_ENDPOINT_DESCRIPTOR)p;
				max_len = endp_descriptor->wMaxPacketSize;
				break;
			}
			pipe_count++;	// fix Ver1.1
		}
		p += p[0];
		len -= p[0];
	}
	free(buf);
	return max_len;
}


void main(void){
	HUSB husb;
	HANDLE hContinuous, hDrSet, hDDrSet;
	DWORD size, ret, i, maxlen;
	
	/* p */
	struct udata	ibuf;
	struct udr		obuf;
	struct uddr		cmd;

	/* USBfoCX̃I[v */
	husb = Uusbd_Open();
	if(husb == INVALID_HANDLE_VALUE){
	}else{
		printf("USBnh:%d\n",husb);
	}

	/* USBfoCX̊mF */
	ret = Uusbd_Check(husb);
	switch(ret){
		case UU_CHECK_OK:
			printf("USBnh:%d ͐ɓ삵Ă܂.\n",husb);
			break;
		case UU_CHECK_NOTOPEN:
			printf("USBnh:%d ͖ł.\n",husb);
			break;
		case UU_CHECK_NODEVICE:
			printf("USBnh:%d ͎OĂ܂.\n",husb);
			break;
	}

	/* Ŝ̑傫m */
	maxlen = get_max_packet(husb, 0, 0);
	if(maxlen == 0) {
		printf("Can't Get max packet length\n");
		return;
	}
	printf("max packet size =%d\n",maxlen);

	/* pCṽI[v */
	hDrSet = Uusbd_OpenPipe(husb, 0, 3);
	if(hDrSet == INVALID_HANDLE_VALUE){
		printf("DRWX^ݗp̃pCvI[vɎs.\n");
	}
	hDDrSet = Uusbd_OpenPipe(husb, 0, 1);
	if(hDDrSet == INVALID_HANDLE_VALUE){
		printf("DDRWX^ݗp̃pCvI[vɎs.\n");
	}
	hContinuous = Uusbd_OpenPipe(husb, 0, 2);
	if(hContinuous == INVALID_HANDLE_VALUE){
		printf("f[^ǂݍݗp̃pCvI[vɎs.\n");
	}

	/* DDRWX^̏ */
	cmd.P9DDR = 0xff;  /*Sďo*/
	cmd.PADDR = 0xff;  /*Sďo*/
	cmd.PBDDR = 0xff;  /*Sďo*/

	/* f[^̏ */
	if(WriteFile(hDDrSet, &cmd, sizeof(cmd), &size, NULL)<0){
		printf("DDRWX^݃G[.\n");
	}
	/* USBfoCX̃Zbg */
	Uusbd_ResetPipe(hDDrSet);
	printf("OK.\n");

	/* DRWX^̏ */
	obuf.retval=1;
	obuf.P9DR = 0x00;
	obuf.PADR = 0x00;
	obuf.PBDR = 0x00;

	/* f[^̏ */
	if(WriteFile(hDrSet, &obuf, sizeof(obuf), &size, NULL)<0){
		printf("DRWX^݃G[.\n");
	}
	
	/* USBfoCX̃Zbg */
	Uusbd_ResetPipe(hDrSet);
	printf("OK2.\n");

	i = 0;
	for(;;){

		if((i&0x01) == 0x00){
			obuf.PADR = 0x00;
			obuf.PBDR = 0x00;
		}else{
			obuf.PADR = 0xff;
			obuf.PBDR = 0xff;
		}
		i++;
		Sleep(1000);

		/* f[^̏ */
		if(WriteFile(hDrSet, &obuf, sizeof(obuf), &size, NULL)<0){
			printf("DRWX^݃G[.\n");
		}
		
		/* USBfoCX̃Zbg */
		Uusbd_ResetPipe(hDrSet);

		ret = ReadFile(hContinuous, &ibuf, maxlen, &size, NULL);
		if(ret ==0 || size == 0) {
			printf("read error ret=%d size=%d\n",ret,size);
			ret = Uusbd_Check(husb);
			if(ret != UU_CHECK_OK) {
				printf("foCXO܂\n");
				break;
			}
			/* pCṽZbg */
			Uusbd_ResetPipe(hContinuous);
			Sleep(1000);
			continue;
		}
		printf("%4d %4d %4d %4d %4d %4d %4d %4d [P9]0x%2X [PA]0x%2X [PB]0x%2X\r",
				ibuf.ad[0]>>5,ibuf.ad[1]>>5,ibuf.ad[2]>>5,ibuf.ad[3]>>5,
				ibuf.ad[4]>>5,ibuf.ad[5]>>5,ibuf.ad[6]>>5,ibuf.ad[7]>>5,
				ibuf.P9DR,ibuf.PADR,ibuf.PBDR);
		/* USBfoCX̃Zbg */
		Uusbd_ResetPipe(hContinuous);

	}

	CloseHandle(hContinuous);
	CloseHandle(hDrSet);
	CloseHandle(hDDrSet);
	Uusbd_Close(husb);
}